# WARNING: Do not edit by hand, this file was generated by Crank:
#
#   https://github.com/gocardless/crank
#

import json

import requests
import responses
from nose.tools import (
  assert_equal,
  assert_is_instance,
  assert_is_none,
  assert_is_not_none,
  assert_not_equal,
  assert_raises
)

from gocardless_pro.errors import MalformedResponseError
from gocardless_pro import resources
from gocardless_pro import list_response

from .. import helpers
  

@responses.activate
def test_negative_balance_limits_list():
    fixture = helpers.load_fixture('negative_balance_limits')['list']
    helpers.stub_response(fixture)
    response = helpers.client.negative_balance_limits.list(*fixture['url_params'])
    body = fixture['body']['negative_balance_limits']

    assert_is_instance(response, list_response.ListResponse)
    assert_is_instance(response.records[0], resources.NegativeBalanceLimit)

    assert_equal(response.before, fixture['body']['meta']['cursors']['before'])
    assert_equal(response.after, fixture['body']['meta']['cursors']['after'])
    assert_is_none(responses.calls[-1].request.headers.get('Idempotency-Key'))
    assert_equal([r.active for r in response.records],
                 [b.get('active') for b in body])
    assert_equal([r.balance_limit for r in response.records],
                 [b.get('balance_limit') for b in body])
    assert_equal([r.created_at for r in response.records],
                 [b.get('created_at') for b in body])
    assert_equal([r.currency for r in response.records],
                 [b.get('currency') for b in body])
    assert_equal([r.id for r in response.records],
                 [b.get('id') for b in body])
    assert_equal([r.reason for r in response.records],
                 [b.get('reason') for b in body])
    assert_equal([r.updated_at for r in response.records],
                 [b.get('updated_at') for b in body])

@responses.activate
def test_timeout_negative_balance_limits_list_retries():
    fixture = helpers.load_fixture('negative_balance_limits')['list']
    with helpers.stub_timeout_then_response(fixture) as rsps:
      response = helpers.client.negative_balance_limits.list(*fixture['url_params'])
      assert_equal(2, len(rsps.calls))
      assert_equal(rsps.calls[0].request.headers.get('Idempotency-Key'),
                   rsps.calls[1].request.headers.get('Idempotency-Key'))
    body = fixture['body']['negative_balance_limits']

    assert_is_instance(response, list_response.ListResponse)
    assert_is_instance(response.records[0], resources.NegativeBalanceLimit)

    assert_equal(response.before, fixture['body']['meta']['cursors']['before'])
    assert_equal(response.after, fixture['body']['meta']['cursors']['after'])

def test_502_negative_balance_limits_list_retries():
    fixture = helpers.load_fixture('negative_balance_limits')['list']
    with helpers.stub_502_then_response(fixture) as rsps:
      response = helpers.client.negative_balance_limits.list(*fixture['url_params'])
      assert_equal(2, len(rsps.calls))
      assert_equal(rsps.calls[0].request.headers.get('Idempotency-Key'),
                   rsps.calls[1].request.headers.get('Idempotency-Key'))
    body = fixture['body']['negative_balance_limits']

    assert_is_instance(response, list_response.ListResponse)
    assert_is_instance(response.records[0], resources.NegativeBalanceLimit)

    assert_equal(response.before, fixture['body']['meta']['cursors']['before'])
    assert_equal(response.after, fixture['body']['meta']['cursors']['after'])

@responses.activate
def test_negative_balance_limits_all():
    fixture = helpers.load_fixture('negative_balance_limits')['list']

    def callback(request):
        if 'after=123' in request.url:
          fixture['body']['meta']['cursors']['after'] = None
        else:
          fixture['body']['meta']['cursors']['after'] = '123'
        return [200, {}, json.dumps(fixture['body'])]

    url = 'http://example.com' + fixture['path_template']
    responses.add_callback(fixture['method'], url, callback)

    all_records = list(helpers.client.negative_balance_limits.all())
    assert_equal(len(all_records), len(fixture['body']['negative_balance_limits']) * 2)
    for record in all_records:
      assert_is_instance(record, resources.NegativeBalanceLimit)
    
  

@responses.activate
def test_negative_balance_limits_create():
    fixture = helpers.load_fixture('negative_balance_limits')['create']
    helpers.stub_response(fixture)
    response = helpers.client.negative_balance_limits.create(*fixture['url_params'])
    body = fixture['body']['negative_balance_limits']

    assert_is_instance(response, resources.NegativeBalanceLimit)
    assert_is_not_none(responses.calls[-1].request.headers.get('Idempotency-Key'))
    assert_equal(response.active, body.get('active'))
    assert_equal(response.balance_limit, body.get('balance_limit'))
    assert_equal(response.created_at, body.get('created_at'))
    assert_equal(response.currency, body.get('currency'))
    assert_equal(response.id, body.get('id'))
    assert_equal(response.reason, body.get('reason'))
    assert_equal(response.updated_at, body.get('updated_at'))
    assert_equal(response.links.creator_user,
                 body.get('links')['creator_user'])
    assert_equal(response.links.creditor,
                 body.get('links')['creditor'])

@responses.activate
def test_timeout_negative_balance_limits_create_retries():
    fixture = helpers.load_fixture('negative_balance_limits')['create']
    with helpers.stub_timeout_then_response(fixture) as rsps:
      response = helpers.client.negative_balance_limits.create(*fixture['url_params'])
      assert_equal(2, len(rsps.calls))
      assert_equal(rsps.calls[0].request.headers.get('Idempotency-Key'),
                   rsps.calls[1].request.headers.get('Idempotency-Key'))
    body = fixture['body']['negative_balance_limits']

    assert_is_instance(response, resources.NegativeBalanceLimit)

def test_502_negative_balance_limits_create_retries():
    fixture = helpers.load_fixture('negative_balance_limits')['create']
    with helpers.stub_502_then_response(fixture) as rsps:
      response = helpers.client.negative_balance_limits.create(*fixture['url_params'])
      assert_equal(2, len(rsps.calls))
      assert_equal(rsps.calls[0].request.headers.get('Idempotency-Key'),
                   rsps.calls[1].request.headers.get('Idempotency-Key'))
    body = fixture['body']['negative_balance_limits']

    assert_is_instance(response, resources.NegativeBalanceLimit)
  
